common/xfs: refactor agcount calculation for mounted filesystems
[xfstests-dev.git] / tests / xfs / 085
index 9873530e62ab13f43ccbd0d0ec17f56b95b4ae99..18ddeff8e56a559d93a6043fb7c744640e4c9e61 100755 (executable)
 #! /bin/bash
-# FS QA Test No. 085
-#
-# To test log replay by shutdown of file system
-# This is the first simple initial test to ensure that
-# the goingdown ioctl is working and recovery of
-# create transactions is working.
-#
-#-----------------------------------------------------------------------
-# Copyright (c) 2000-2003 Silicon Graphics, Inc.  All Rights Reserved.
+# SPDX-License-Identifier: GPL-2.0
+# Copyright (c) 2015 Oracle, Inc.  All Rights Reserved.
 #
-# This program is free software; you can redistribute it and/or
-# modify it under the terms of the GNU General Public License as
-# published by the Free Software Foundation.
-#
-# This program is distributed in the hope that it would be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write the Free Software Foundation,
-# Inc.,  51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+# FS QA Test No. 085
 #
-#-----------------------------------------------------------------------
+# Create and populate an XFS filesystem, corrupt a superblock, then see how
+# the kernel and xfs_repair deal with it.
 #
-
 seq=`basename $0`
 seqres=$RESULT_DIR/$seq
-seqres=$RESULT_DIR/$seq
-seqres=$RESULT_DIR/$seq
 echo "QA output created by $seq"
 
 here=`pwd`
 tmp=/tmp/$$
 status=1       # failure is the default!
-trap "rm -f $tmp.*; exit \$status" 0 1 2 3 15
+trap "_cleanup; exit \$status" 0 1 2 3 15
+
+_cleanup()
+{
+    cd /
+    #rm -f $tmp.*
+}
 
 # get standard environment, filters and checks
 . ./common/rc
 . ./common/filter
-. ./common/log
+. ./common/attr
+. ./common/populate
 
 # real QA test starts here
 _supported_fs xfs
-_supported_os IRIX Linux
-
-rm -f $seqres.full
-rm -f $tmp.log
+_supported_os Linux
 
 _require_scratch
+test -n "${FORCE_FUZZ}" || _require_scratch_xfs_crc
+_require_attrs
+_require_populate_commands
+_require_xfs_db_blocktrash_z_command
 
-echo "mkfs"
-_scratch_mkfs_xfs >>$seqres.full 2>&1 \
-    || _fail "mkfs scratch failed"
-
-echo "mount"
-_scratch_mount >>$seqres.full 2>&1 \
-    || _fail "mount failed: $MOUNT_OPTIONS"
-
-echo "touch files"
-touch $SCRATCH_MNT/{0,1,2,3,4,5,6,7,8,9}{0,1,2,3,4,5,6,7,8,9}
-
-echo "godown"
-src/godown -v -f $SCRATCH_MNT >> $seqres.full
-
-echo "unmount"
-umount $SCRATCH_MNT
-
-echo "logprint after going down..."
-_print_logstate
-
-# curious if FS consistent at start
-if false; then
-    if $XFS_CHECK_PROG $SCRATCH_DEV; then
-       echo "*** checked ok ***"
-    fi
-fi
-
-echo "mount with replay"
-_scratch_mount $mnt >>$seqres.full 2>&1 \
-    || _fail "mount failed: $mnt $MOUNT_OPTIONS"
-
-echo "ls SCRATCH_MNT"
-ls $SCRATCH_MNT
-
-echo "unmount"
-umount $SCRATCH_MNT
-
-echo "logprint after mount and replay..."
-_print_logstate
-
-if _check_scratch_fs; then
-    echo "filesystem is checked ok"
-else
-    echo "filesystem is NOT ok"
-fi
+rm -f $seqres.full
+TESTDIR="${SCRATCH_MNT}/scratchdir"
+TESTFILE="${TESTDIR}/testfile"
+
+echo "+ create scratch fs"
+_scratch_mkfs_xfs > /dev/null
+
+echo "+ mount fs image"
+_scratch_mount
+blksz="$(stat -f -c '%s' "${SCRATCH_MNT}")"
+
+echo "+ make some files"
+mkdir -p "${TESTDIR}"
+for x in `seq 1 1024`; do
+       touch "${SCRATCH_MNT}/junk.${x}"
+       inode="$(stat -c '%i' "${SCRATCH_MNT}/junk.${x}")"
+       if [ "$x" -gt 512 ] && [ "$((inode % 64))" -eq 0 ]; then
+               mv "${SCRATCH_MNT}/junk.${x}" "${TESTFILE}.1"
+               break
+       fi
+done
+for x in `seq 2 64`; do
+       touch "${TESTFILE}.${x}"
+done
+inode="$(stat -c '%i' "${TESTFILE}.1")"
+agcount="$(_xfs_mount_agcount $SCRATCH_MNT)"
+umount "${SCRATCH_MNT}"
+
+echo "+ check fs"
+_scratch_xfs_repair -n >> $seqres.full 2>&1 || _fail "xfs_repair should not fail"
+
+echo "+ corrupt image"
+$XFS_IO_PROG -f -c "pwrite -S 0x62 32 4" "${SCRATCH_DEV}" >> $seqres.full
+
+echo "+ mount image"
+_try_scratch_mount 2>/dev/null && _fail "mount should not succeed"
+
+echo "+ repair fs"
+_scratch_xfs_repair >> $seqres.full 2>&1
+
+echo "+ mount image (2)"
+_scratch_mount
+
+echo "+ chattr -R -i"
+$CHATTR_PROG -R -f -i "${SCRATCH_MNT}/"
+
+echo "+ modify files (2)"
+broken=0
+for x in `seq 1 64`; do
+       test -e "${TESTFILE}.${x}" || continue
+       echo moo | dd oflag=append conv=notrunc of="${TESTFILE}.${x}" 2>/dev/null
+       test $? -ne 0 && broken=1
+done
+echo "broken: ${broken}"
+umount "${SCRATCH_MNT}"
+
+echo "+ check fs (2)"
+_scratch_xfs_repair -n >> $seqres.full 2>&1 || _fail "xfs_repair should not fail"
 
-# success, all done
 status=0
 exit